## fckit 0.14.2

=== CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

############################################################################################
# FCKIT

cmake_minimum_required( VERSION 3.17 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )

project( fckit LANGUAGES C CXX Fortran )

set(CMAKE_DIRECTORY_LABELS "fckit")
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

################################################################################################
# options & dependencies

### Fortran ...
ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module )

ecbuild_check_fortran( FEATURES finalization )

set( FEATURE_FINAL_DEFAULT ON )
set( PGIBUG_ATLAS_197 0 )
if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI|NVHPC" )
  if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_LESS 19.4 )
      set( PGIBUG_ATLAS_197 1 )
  endif()
  if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_LESS 19.10 )
    # Compilation works, but runtime segmentation faults occur (tested with pgi/17.7)
    set( FEATURE_FINAL_DEFAULT OFF )
  endif()
endif()


ecbuild_add_option( FEATURE FINAL
                    DESCRIPTION "Enable automatic finalisation for derived types (destructors)"
                    DEFAULT ${FEATURE_FINAL_DEFAULT}
                    CONDITION EC_HAVE_Fortran_FINALIZATION )

if( fckit_HAVE_FINAL )
    include( final-support )
    check_final_support()
    ecbuild_info( "FCKIT_HAVE_FINAL [1]")
    ecbuild_info( "  FCKIT_FINAL_FUNCTION_RESULT                      = ${FCKIT_FINAL_FUNCTION_RESULT}")
    ecbuild_info( "  FCKIT_FINAL_UNINITIALIZED_LOCAL                  = ${FCKIT_FINAL_UNINITIALIZED_LOCAL}")
    ecbuild_info( "  FCKIT_FINAL_UNINITIALIZED_INTENT_OUT             = ${FCKIT_FINAL_UNINITIALIZED_INTENT_OUT}")
    ecbuild_info( "  FCKIT_FINAL_UNINITIALIZED_INTENT_INOUT           = ${FCKIT_FINAL_UNINITIALIZED_INTENT_INOUT}")
    ecbuild_info( "  FCKIT_FINAL_NOT_PROPAGATING                      = ${FCKIT_FINAL_NOT_PROPAGATING}")
    ecbuild_info( "  FCKIT_FINAL_NOT_INHERITING                       = ${FCKIT_FINAL_NOT_INHERITING}")
    ecbuild_info( "  FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY         = ${FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY}")
    ecbuild_info( "  FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY           = ${FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY}")
    ecbuild_info( "  FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY = ${FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY}")
    ecbuild_info( "  FCKIT_FINAL_NOT_INHERITING_FOR_AUTOMATIC_ARRAY   = ${FCKIT_FINAL_NOT_INHERITING_FOR_AUTOMATIC_ARRAY}")

    if( FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY OR
        FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY OR
        FCKIT_FINAL_NOT_INHERITING_FOR_ALLOCATABLE_ARRAY OR
        FCKIT_FINAL_NOT_INHERITING_FOR_AUTOMATIC_ARRAY)
      ecbuild_warn("Introspected compiler bugs w.r.t. using derived types with FINAL (destructors)")
    endif()

endif()
if( NOT fckit_HAVE_FINAL )
    ecbuild_info( "fckit_HAVE_FINAL [0]")
    set( FCKIT_FINAL_FUNCTION_RESULT              0 )
    set( FCKIT_FINAL_UNINITIALIZED_LOCAL          0 )
    set( FCKIT_FINAL_UNINITIALIZED_INTENT_OUT     0 )
    set( FCKIT_FINAL_UNINITIALIZED_INTENT_INOUT   0 )
    set( FCKIT_FINAL_NOT_PROPAGATING              0 )
    set( FCKIT_FINAL_NOT_INHERITING               0 )
    set( FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY 0 )
    set( FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY   0 )
endif()

ecbuild_find_package( NAME eckit VERSION 1.14 QUIET )
ecbuild_add_option( FEATURE ECKIT
                    DESCRIPTION "Wrap ecKit functionality"
                    CONDITION eckit_FOUND )
if( NOT fckit_HAVE_ECKIT )
    ecbuild_warn("ecKit could not be found. This disables various fckit features such as MPI, Configuration, Logging")
endif()

## MPI
set( fckit_HAVE_ECKIT_MPI_PARALLEL 0 )
if( fckit_HAVE_ECKIT )
  if( eckit_HAVE_MPI OR ECKIT_HAVE_MPI )
    set( fckit_HAVE_ECKIT_MPI_PARALLEL 1 )
    set( HAVE_MPI 1 )
  else()
    set( fckit_HAVE_ECKIT_MPI_PARALLEL 0 )
    set( HAVE_MPI 0 )
  endif()
endif()
set( fckit_HAVE_MPI ${HAVE_MPI} )
if( fckit_HAVE_ECKIT )
  if( NOT fckit_HAVE_MPI )
    ecbuild_warn("ecKit has been compiled without MPI. This causes fckit to not be able to run parallel executables.")
  else()
    ecbuild_info("ecKit has been compiled with MPI")
  endif()
endif()

################################################################################################
# export package info

set( FCKIT_LIBRARIES  fckit )

################################################################################################
# install python venv with rumael.yaml and fypp
include( fckit_install_venv )
set( install_permissions OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE )

# Discover only system install Python 3
set( Python3_FIND_VIRTUALENV STANDARD )
find_package( Python3 COMPONENTS Interpreter )

ecbuild_add_option( FEATURE FCKIT_VENV
                    DEFAULT OFF
                    DESCRIPTION "Install Python virtual environment with fypp and a yaml parser"
                    CONDITION Python3_VERSION VERSION_GREATER_EQUAL 3.8 )

ecbuild_add_option( FEATURE FCKIT_VENV_EDITABLE
                    DEFAULT OFF
                    DESCRIPTION "Install editable packages in fckit Python virtual environment"
                    CONDITION HAVE_FCKIT_VENV )

ecbuild_add_option( FEATURE FCKIT_VENV_INSTALL
                    DEFAULT OFF
                    DESCRIPTION "CMake install Python virtual environment with fypp and a yaml parser"
                    CONDITION HAVE_FCKIT_VENV )

if( HAVE_FCKIT_VENV )
   fckit_install_venv()
else()
   # install fypp runner script only
   set( FYPP ${CMAKE_CURRENT_SOURCE_DIR}/tools/fckit-eval.sh
             ${CMAKE_CURRENT_SOURCE_DIR}/contrib/fypp-3.2-b8dd58b-20230822/bin/fypp )

   install( FILES contrib/fypp-3.2-b8dd58b-20230822/bin/fypp DESTINATION libexec RENAME fckit-fypp.py
            PERMISSIONS ${install_permissions} )
endif()

################################################################################################
# sources

set( FCTEST_GENERATOR ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/tools/fctest-generate-runner.py )
include( fckit_preprocess_fypp )
include( add_fctest )

add_subdirectory( src )
add_subdirectory( doc )

################################################################################################
# finalize

ecbuild_print_summary()
################################################################################################

if( ECBUILD_INSTALL_FORTRAN_MODULES )
    install( DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}
             DESTINATION module/fckit
             COMPONENT modules )
endif()
if( NOT PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME )
  set( FCTEST_GENERATOR ${FCTEST_GENERATOR} PARENT_SCOPE )
  set( FYPP ${FYPP} PARENT_SCOPE )
endif()
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/cmake/add_fctest.cmake ADD_FCTEST)
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/cmake/fckit_preprocess_fypp.cmake FCKIT_PREPROCESS_FYPP )

install( FILES tools/fctest-generate-runner.py DESTINATION libexec PERMISSIONS ${install_permissions} )
install( FILES tools/fckit-eval.sh DESTINATION libexec PERMISSIONS ${install_permissions} )

ecbuild_install_project( NAME fckit )

=== src/tests/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

cmake_policy( SET CMP0064 NEW ) # Recognize ``TEST`` as operator for the ``if()`` command. (introduced in CMake version 3.4)

add_fctest( TARGET  fckit_test_array
            LINKER_LANGUAGE Fortran
            SOURCES test_array.F90
            LIBS    fckit)

add_fctest( TARGET  fckit_test_resource
            LINKER_LANGUAGE Fortran
            SOURCES test_resource.F90
            ARGS    -integer 10 -long 5000000000 -float 0.123456 -double 0.1234567890123456789 -string "hello world"
            CONDITION HAVE_ECKIT
            LIBS    fckit)

add_fctest( TARGET  fckit_test_log
            LINKER_LANGUAGE Fortran
            SOURCES test_log.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)

add_fctest( TARGET  fckit_test_shared_ptr
            LINKER_LANGUAGE Fortran
            SOURCES
              test_shared_ptr.F90
              test_shared_ptr.cc
            LIBS    fckit)

add_fctest( TARGET  fckit_test_owned_object
            LINKER_LANGUAGE Fortran
            SOURCES
              test_owned_object.F90
              test_owned_object.cc
            LIBS    fckit eckit
            CONDITION HAVE_ECKIT
          )

add_fctest( TARGET  fckit_test_mpi
            LINKER_LANGUAGE Fortran
            SOURCES test_mpi.F90
            MPI 4
            CONDITION HAVE_MPI
            LIBS    fckit)

add_fctest( TARGET  fckit_test_abort
            LINKER_LANGUAGE Fortran
            SOURCES test_abort.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)

add_fctest( TARGET  fckit_test_map
            LINKER_LANGUAGE Fortran
            SOURCES test_map.F90
            CONDITION FCKIT_HAVE_ECKIT_TENSOR
            LIBS    fckit)            

add_fctest( TARGET  fckit_test_tensor
            LINKER_LANGUAGE Fortran
            SOURCES 
              test_tensor.F90
              test_tensor.cc
            INCLUDES ${ECKIT_INCLUDE_DIRS}
            CONDITION FCKIT_HAVE_ECKIT_TENSOR
            LIBS  eckit fckit)            


add_fctest( TARGET  fckit_test_configuration
            LINKER_LANGUAGE Fortran
            SOURCES test_configuration.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)
if( TEST fckit_test_configuration )
  if( NOT CMAKE_VERSION VERSION_LESS 3.15 ) # support for COMPILE_LANG_AND_ID generator expression
    target_compile_options( fckit_test_configuration PRIVATE $<$<COMPILE_LANG_AND_ID:Fortran,GNU>:-Wno-uninitialized> )
  endif()
endif()

add_fctest( TARGET  fckit_test_configuration_fails
            LINKER_LANGUAGE Fortran
            SOURCES test_configuration_fails.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)
if( TEST fckit_test_configuration_fails )
    set_tests_properties( fckit_test_configuration_fails PROPERTIES
        PASS_REGULAR_EXPRESSION "Could not find \"missing\" in Configuration"
        TIMEOUT 20 )
endif()

add_fctest( TARGET  fckit_test_broadcast_file
            LINKER_LANGUAGE Fortran
            SOURCES test_broadcast_file.F90
            MPI 4
            CONDITION HAVE_MPI
            LIBS    fckit)

add_fctest( TARGET fckit_test_fypp
  LINKER_LANGUAGE Fortran
  SOURCES test_fypp.fypp
  LIBS fckit
)

ecbuild_add_test( TARGET  fckit_test_configuration_cpp
            LINKER_LANGUAGE Fortran
            SOURCES
            test_configuration.cc
            test_configuration_fortcode.F90
            INCLUDES ${ECKIT_INCLUDE_DIRS}
            CONDITION HAVE_ECKIT
            LIBS    fckit  eckit eckit_mpi )

if( TEST fckit_test_configuration_cpp )
  set_property( TEST fckit_test_configuration_cpp APPEND PROPERTY LABELS "fortran" )
endif()

ecbuild_add_test( TARGET fckit_test_cpp
  LINKER_LANGUAGE Fortran
  SOURCES test_cpp.cc test_cpp_fortcode.F90
  INCLUDES ${ECKIT_INCLUDE_DIRS}
  ENVIRONMENT "DEBUG=1"
  CONDITION HAVE_ECKIT
  LIBS fckit eckit eckit_mpi )

### Fix linking for C++ test executables linked with Fortran linker
if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI|NVHPC" )
  set( NO_MAIN "-Mnomain" )
elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
  set( NO_MAIN "-nofor-main" )
elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Fujitsu" )
  set( NO_MAIN "-mlcmain=main" )
elseif( CMAKE_Fortran_COMPILER_ID STREQUAL "Flang" )
  # we use STREUQAL to avoid a false match with LLVMFlang
  set( NO_MAIN "-fno-fortran-main" )
endif()
if( NO_MAIN )
  foreach( _test fckit_test_configuration_cpp fckit_test_cpp )
    if( TEST ${_test} )
      set_target_properties(${_test} PROPERTIES LINK_FLAGS ${NO_MAIN} )
    endif()
  endforeach()
endif()

### Quarantaine tests if requested
foreach( _test ${FCKIT_QUARANTAINED_TESTS} )
    if( TEST ${_test} )
      set_tests_properties( ${_test} PROPERTIES DISABLED 1 )
      ecbuild_warn("Test ${_test} is quarantined (shows as not run)")
    endif()
endforeach()

### Test downstream find_package(fckit) projects
add_subdirectory( test_downstream_fypp )
add_subdirectory( test_downstream_fctest )

### Test fckit_yaml_reader
if( HAVE_FCKIT_VENV )
   ecbuild_add_test( COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/fckit_run_pytest.sh
                     ARGS ${CMAKE_CURRENT_BINARY_DIR}/../.. ${CMAKE_CURRENT_SOURCE_DIR} )
endif()

=== debian/changelog ===
fckit (0.14.2-1) unstable; urgency=medium

  [ Alastair McKinstry ]
  * New upstream release
  * Fix d/copyright format for licenserecon
  * Use pre-computed DEB_HOST_MULTIARCH
  * Add d/salsa-ci.yml
  * Move dh-sequence-fortran-mod to dh-sequence-fortran
  * Drop dh_dwz as automatically handled by dh_fortran
  * Use dh_fortran_lib to handle libraries
  * Build with lfortran, flang-21 as optional compilers for testing
  * Now need get_ld_flags for cmake/flang linking
  * Standards-Version: 4.7.3
  * Drop priority: optional
  * Make Science team the maintainer, myself the uploader
  * Update the VCS as its now in debian-science-team
  * Don't set RPATHS
  * Build against gfortran-15,flang-21

  [ Andreas Tille ]
  * d/watch: version=5

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Feb 2026 13:25:09 +0000

=== debian/control ===
Source: fckit
Section: science
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-fortran,
  gfortran-15,
  flang-21,
  lfortran,
  ecbuild (>= 3.3.0-2),
  python3-all,
  libeckit-dev (>= 1.29.1-1~),
  libssl-dev,
  libcurl4-gnutls-dev
Standards-Version: 4.7.3
Homepage: https://github.com/ecmwf/fckit
Vcs-Browser: https://salsa.debian.org/science-team/fckit
Vcs-Git: https://salsa.debian.org/science-team/fckit.git

Package: libfckit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfckit0d (= ${binary:Version}), ${shlib:Depends}, ${misc:Depends},
 ${fortran:Depends}, libeckit-dev
Description: Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libfckit0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libfckit-utils
Architecture: all
Depends: ${misc:Depends}, libfckit-dev, python3
Description: Library Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/debhelper/dh-fortran/fortran-support.mk

export FC_DEFAULT:= gfortran-15
export FC_OPTIONAL:=flang-21

export DH_VERBOSE=1

TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR:=/usr/include/$(DEB_HOST_MULTIARCH)
FMODDIR:=$(shell dh_fortran get_fmoddir)
# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

BUILD_FLAGS = 

NO_TEST_ARCH:= mips64el 
DO_TEST:= $(if $(filter $(DEB_TARGET_ARCH), $(NO_TEST_ARCH)), false, true)

%:
	dh $@ --buildsystem=ecbuild --with fortran

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/build-*
		

override_dh_auto_configure:
	for f in $(FC_DEFAULT) $(FC_OPTIONAL) ; do \
		FCFLAGS=`dh_fortran get_fc_flags --fc $$f` ; \
		LDFLAGS=`dh_fortran get_ld_flags --fc $$f`  \
		dh_auto_configure --builddirectory=debian/build-$$f  -- \
			${BUILD_FLAGS} \
			-DCMAKE_Fortran_COMPILER=$$f \
			-DCMAKE_Fortran_FLAGS="$${FCFLAGS}" \
			-DCMAKE_SKIP_INSTALL_RPATH=On ; \
		done

override_dh_auto_test:
	$(DO_TEST) && (  for f in $(FC_DEFAULT) $(FC_OPTIONAL) ; do \
		dh_auto_test --builddirectory=debian/build-$$f ; \
		done )   || echo "Ignoring test failures"

override_dh_auto_build:
	for f in $(FC_DEFAULT) $(FC_OPTIONAL) ; do \
		dh_auto_build --builddirectory=debian/build-$$f ; done

override_dh_auto_install:
	dh_auto_install --builddirectory=debian/build-$(FC_DEFAULT)
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	sed -i -e 's%$${fckit_INSTALL_PREFIX}/libexec%/usr/bin%g'        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%$${fckit_BASE_DIR}/libexec%/usr/bin%g'                           $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%${CURDIR}%/build/fckit/%g'     	        	              $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%/usr/bin/python %/usr/bin/python3 %g'               	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fckit-fypp.py%fckit-fypp%' 		         	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fckit-eval.sh%fckit-eval%'                          	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fctest-generate-runner.py%fctest-generate-runner%'  	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  		 	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libfckit%${LIBDIR}/libfckit%g'            $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/module%${FMODDIR}%g' 			      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%python3\.[0-9]*%python3%g'  				      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	# TODO: This will need work when flang is supported
	sed -i -e 's%libfckit.so.0d%libfckit-${FC_DEFAULT}.so.0d%g'			      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets-release.cmake
	# rename those with script extensions
	mv $(TMPDIR)/usr/libexec/fckit-eval.sh $(TMPDIR)/usr/libexec/fckit-eval
	mv $(TMPDIR)/usr/libexec/fckit-fypp.py $(TMPDIR)/usr/libexec/fckit-fypp
	mv $(TMPDIR)/usr/libexec/fctest-generate-runner.py $(TMPDIR)/usr/libexec/fctest-generate-runner
	chmod -x $(TMPDIR)/$(LIBDIR)/cmake/fckit/*
